using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace Metadata
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void btnopen_Click(object sender, EventArgs e)
        {
            //
            //create the image object
            //
            Image myImage;
            ofd1.FileName = "";
            ofd1.Filter = "JPEG files(*.jpg)|*.jpg";
            if (ofd1.ShowDialog() == DialogResult.OK)
            {
                myImage = Image.FromFile(ofd1.FileName);
                lblpath.Text = ofd1.FileName.ToString();
            }
            else
            {
                myImage = new Bitmap(100, 100);
            }
            lblheight.Text = myImage.Height.ToString();
            lblwidth.Text = myImage.Width.ToString();
            lblh.Text = myImage.HorizontalResolution.ToString()+ " dpi";
            lblv.Text = myImage.VerticalResolution.ToString() + " dpi";
            lblformat.Text = myImage.PixelFormat.ToString();
            picpad.Image = myImage;
            //
            // Get the PropertyItems property from image.
            //
            PropertyItem[] propitems = myImage.PropertyItems;
            //
            // For each PropertyItem in the array, display the id, 
            // type, and length.
            //
            int count = 1;
            Encoding myencoder = Encoding.UTF8;
            list1.Items.Clear();
            StringBuilder sb = new StringBuilder();
            bool encode = true;
            #region "Foeach"
            foreach (PropertyItem propitem in propitems)
            {
                ListViewItem row = new ListViewItem(count.ToString());
                row.SubItems.Add("0x" + propitem.Id.ToString("X").ToUpper());
                encode = true;
                string s = "Uknow Property";
                switch (propitem.Id)
                {
                    case 0x0000:
                        s = "GpsVer";
                        break;
                    case 0x0001:
                        s = "GpsLatitudeRef ";
                        break;
                    case 0x0002:
                        s = "GpsLatitude ";
                        break;
                    case 0x0003:
                        s = "GpsLongitudeRef ";
                        break;
                    case 0x0004:
                        s = "GpsLongitude ";
                        break;
                    case 0x0005:
                        s = "GpsAltitudeRef ";
                        break;
                    case 0x0006:
                        s = "GpsAltitude ";
                        break;
                    case 0x0007:
                        s = "GpsGpsTime ";
                        break;
                    case 0x0008:
                        s = "GpsGpsSatellites ";
                        break;
                    case 0x0009:
                        s = "GpsGpsStatus ";
                        break;
                    case 0x000A:
                        s = "GpsGpsMeasureMode ";
                        break;
                    case 0x000B:
                        s = "GpsGpsDop ";
                        break;
                    case 0x000C:
                        s = "GpsSpeedRef ";
                        break;
                    case 0x000D:
                        s = "GpsSpeed ";
                        break;
                    case 0x000E:
                        s = "GpsTrackRef ";
                        break;
                    case 0x000F:
                        s = "GpsTrack ";
                        break;
                    case 0x0010:
                        s = "GpsImgDirRef ";
                        break;
                    case 0x0011:
                        s = "GpsImgDir ";
                        break;
                    case 0x0012:
                        s = "GpsMapDatum ";
                        break;
                    case 0x0013:
                        s = "GpsDestLatRef ";
                        break;
                    case 0x0014:
                        s = "GpsDestLat ";
                        break;
                    case 0x0015:
                        s = "GpsDestLongRef ";
                        break;
                    case 0x0016:
                        s = "GpsDestLong ";
                        break;
                    case 0x0017:
                        s = "GpsDestBearRef ";
                        break;
                    case 0x0018:
                        s = "GpsDestBear ";
                        break;
                    case 0x0019:
                        s = "GpsDestDistRef ";
                        break;
                    case 0x001A:
                        s = "GpsDestDist ";
                        break;
                    case 0x00FE:
                        s = "NewSubfileType ";
                        break;
                    case 0x00FF:
                        s = "SubfileType ";
                        break;
                    case 0x0100:
                        s = "ImageWidth ";
                        break;
                    case 0x0101:
                        s = "ImageHeight ";
                        break;
                    case 0x0102:
                        s = "BitsPerSample ";
                        break;
                    case 0x0103:
                        s = "Compression ";
                        break;
                    case 0x0106:
                        s = "PhotometricInterp ";
                        break;
                    case 0x0107:
                        s = "ThreshHolding ";
                        break;
                    case 0x0108:
                        s = "CellWidth ";
                        break;
                    case 0x0109:
                        s = "CellHeight ";
                        break;
                    case 0x010A:
                        s = "FillOrder ";
                        break;
                    case 0x010D:
                        s = "DocumentName ";
                        break;
                    case 0x010E:
                        s = "ImageDescription ";
                        break;
                    case 0x010F:
                        s = "EquipMake ";
                        break;
                    case 0x0110:
                        s = "EquipModel ";
                        break;
                    case 0x0111:
                        s = "StripOffsets ";
                        break;
                    case 0x0112:
                        s = "Orientation ";
                        break;
                    case 0x0115:
                        s = "SamplesPerPixel ";
                        break;
                    case 0x0116:
                        s = "RowsPerStrip ";
                        break;
                    case 0x0117:
                        s = "StripBytesCount ";
                        break;
                    case 0x0118:
                        s = "MinSampleValue ";
                        break;
                    case 0x0119:
                        s = "MaxSampleValue ";
                        break;
                    case 0x011A:
                        s = "XResolution ";
                        break;
                    case 0x011B:
                        s = "YResolution ";
                        break;
                    case 0x011C:
                        s = "PlanarConfig ";
                        break;
                    case 0x011D:
                        s = "PageName ";
                        break;
                    case 0x011E:
                        s = "XPosition ";
                        break;
                    case 0x011F:
                        s = "YPosition ";
                        break;
                    case 0x0120:
                        s = "FreeOffset ";
                        break;
                    case 0x0121:
                        s = "FreeByteCounts ";
                        break;
                    case 0x0122:
                        s = "GrayResponseUnit ";
                        break;
                    case 0x0123:
                        s = "GrayResponseCurve ";
                        break;
                    case 0x0124:
                        s = "T4Option ";
                        break;
                    case 0x0125:
                        s = "T6Option ";
                        break;
                    case 0x0128:
                        s = "ResolutionUnit ";
                        break;
                    case 0x0129:
                        s = "PageNumber ";
                        break;
                    case 0x012D:
                        s = "TransferFunction ";
                        break;
                    case 0x0131:
                        s = "SoftwareUsed ";
                        break;
                    case 0x0132:
                        s = "DateTime ";
                        break;
                    case 0x013B:
                        s = "Artist ";
                        break;
                    case 0x013C:
                        s = "HostComputer ";
                        break;
                    case 0x013D:
                        s = "Predictor ";
                        break;
                    case 0x013E:
                        s = "WhitePoint ";
                        break;
                    case 0x013F:
                        s = "PrimaryChromaticities ";
                        break;
                    case 0x0140:
                        s = "ColorMap ";
                        break;
                    case 0x0141:
                        s = "HalftoneHints ";
                        break;
                    case 0x0142:
                        s = "TileWidth ";
                        break;
                    case 0x0143:
                        s = "TileLength ";
                        break;
                    case 0x0144:
                        s = "TileOffset ";
                        break;
                    case 0x0145:
                        s = "TileByteCounts ";
                        break;
                    case 0x014C:
                        s = "InkSet ";
                        break;
                    case 0x014D:
                        s = "InkNames ";
                        break;
                    case 0x014E:
                        s = "NumberOfInks ";
                        break;
                    case 0x0150:
                        s = "DotRange ";
                        break;
                    case 0x0151:
                        s = "TargetPrinter ";
                        break;
                    case 0x0152:
                        s = "ExtraSamples ";
                        break;
                    case 0x0153:
                        s = "SampleFormat ";
                        break;
                    case 0x0154:
                        s = "SMinSampleValue ";
                        break;
                    case 0x0155:
                        s = "SMaxSampleValue ";
                        break;
                    case 0x0156:
                        s = "TransferRange ";
                        break;
                    case 0x0200:
                        s = "JPEGProc ";
                        break;
                    case 0x0201:
                        s = "JPEGInterFormat ";
                        break;
                    case 0x0202:
                        s = "JPEGInterLength ";
                        break;
                    case 0x0203:
                        s = "JPEGRestartInterval ";
                        break;
                    case 0x0205:
                        s = "JPEGLosslessPredictors ";
                        break;
                    case 0x0206:
                        s = "JPEGPointTransforms ";
                        break;
                    case 0x0207:
                        s = "JPEGQTables ";
                        break;
                    case 0x0208:
                        s = "JPEGDCTables ";
                        break;
                    case 0x0209:
                        s = "JPEGACTables ";
                        break;
                    case 0x0211:
                        s = "YCbCrCoefficients ";
                        break;
                    case 0x0212:
                        s = "YCbCrSubsampling ";
                        break;
                    case 0x0213:
                        s = "YCbCrPositioning ";
                        break;
                    case 0x0214:
                        s = "REFBlackWhite ";
                        break;
                    case 0x0301:
                        s = "Gamma ";
                        break;
                    case 0x0302:
                        s = "ICCProfileDescriptor ";
                        break;
                    case 0x0303:
                        s = "SRGBRenderingIntent ";
                        break;
                    case 0x0320:
                        s = "ImageTitle ";
                        break;
                    case 0x5001:
                        s = "ResolutionXUnit ";
                        break;
                    case 0x5002:
                        s = "ResolutionYUnit ";
                        break;
                    case 0x5003:
                        s = "ResolutionXLengthUnit ";
                        break;
                    case 0x5004:
                        s = "ResolutionYLengthUnit ";
                        break;
                    case 0x5005:
                        s = "PrintFlags ";
                        break;
                    case 0x5006:
                        s = "PrintFlagsVersion ";
                        break;
                    case 0x5007:
                        s = "PrintFlagsCrop ";
                        break;
                    case 0x5008:
                        s = "PrintFlagsBleedWidth ";
                        break;
                    case 0x5009:
                        s = "PrintFlagsBleedWidthScale ";
                        break;
                    case 0x500A:
                        s = "HalftoneLPI ";
                        break;
                    case 0x500B:
                        s = "HalftoneLPIUnit ";
                        break;
                    case 0x500C:
                        s = "HalftoneDegree ";
                        break;
                    case 0x500D:
                        s = "HalftoneShape ";
                        break;
                    case 0x500E:
                        s = "HalftoneMisc ";
                        break;
                    case 0x500F:
                        s = "HalftoneScreen ";
                        break;
                    case 0x5010:
                        s = "JPEGQuality ";
                        break;
                    case 0x5011:
                        s = "GridSize ";
                        break;
                    case 0x5012:
                        s = "ThumbnailFormat ";
                        break;
                    case 0x5013:
                        s = "ThumbnailWidth ";
                        break;
                    case 0x5014:
                        s = "ThumbnailHeight ";
                        break;
                    case 0x5015:
                        s = "ThumbnailColorDepth ";
                        break;
                    case 0x5016:
                        s = "ThumbnailPlanes ";
                        break;
                    case 0x5017:
                        s = "ThumbnailRawBytes ";
                        break;
                    case 0x5018:
                        s = "ThumbnailSize ";
                        break;
                    case 0x5019:
                        s = "ThumbnailCompressedSize ";
                        break;
                    case 0x501A:
                        s = "ColorTransferFunction ";
                        break;
                    case 0x501B:
                        s = "ThumbnailData ";
                        break;
                    case 0x5020:
                        s = "ThumbnailImageWidth ";
                        break;
                    case 0x5021:
                        s = "ThumbnailImageHeight ";
                        break;
                    case 0x5022:
                        s = "ThumbnailBitsPerSample ";
                        break;
                    case 0x5023:
                        s = "ThumbnailCompression ";
                        break;
                    case 0x5024:
                        s = "ThumbnailPhotometricInterp ";
                        break;
                    case 0x5025:
                        s = "ThumbnailImageDescription ";
                        break;
                    case 0x5026:
                        s = "ThumbnailEquipMake ";
                        break;
                    case 0x5027:
                        s = "ThumbnailEquipModel ";
                        break;
                    case 0x5028:
                        s = "ThumbnailStripOffsets ";
                        break;
                    case 0x5029:
                        s = "ThumbnailOrientation ";
                        break;
                    case 0x502A:
                        s = "ThumbnailSamplesPerPixel ";
                        break;
                    case 0x502B:
                        s = "ThumbnailRowsPerStrip ";
                        break;
                    case 0x502C:
                        s = "ThumbnailStripBytesCount ";
                        break;
                    case 0x502D:
                        s = "ThumbnailResolutionX ";
                        break;
                    case 0x502E:
                        s = "ThumbnailResolutionY ";
                        break;
                    case 0x502F:
                        s = "ThumbnailPlanarConfig ";
                        break;
                    case 0x5030:
                        s = "ThumbnailResolutionUnit ";
                        break;
                    case 0x5031:
                        s = "ThumbnailTransferFunction ";
                        break;
                    case 0x5032:
                        s = "ThumbnailSoftwareUsed ";
                        break;
                    case 0x5033:
                        s = "ThumbnailDateTime ";
                        break;
                    case 0x5034:
                        s = "ThumbnailArtist ";
                        break;
                    case 0x5035:
                        s = "ThumbnailWhitePoint ";
                        break;
                    case 0x5036:
                        s = "ThumbnailPrimaryChromaticities ";
                        break;
                    case 0x5037:
                        s = "ThumbnailYCbCrCoefficients ";
                        break;
                    case 0x5038:
                        s = "ThumbnailYCbCrSubsampling ";
                        break;
                    case 0x5039:
                        s = "ThumbnailYCbCrPositioning ";
                        break;
                    case 0x503A:
                        s = "ThumbnailRefBlackWhite ";
                        break;
                    case 0x503B:
                        s = "ThumbnailCopyRight ";
                        break;
                    case 0x5090:
                        s = "LuminanceTable ";
                        break;
                    case 0x5091:
                        s = "ChrominanceTable ";
                        break;
                    case 0x5100:
                        s = "FrameDelay ";
                        break;
                    case 0x5101:
                        s = "LoopCount ";
                        break;
                    case 0x5102:
                        s = "GlobalPalette ";
                        break;
                    case 0x5103:
                        s = "IndexBackground ";
                        break;
                    case 0x5104:
                        s = "IndexTransparent ";
                        break;
                    case 0x5110:
                        s = "PixelUnit ";
                        break;
                    case 0x5111:
                        s = "PixelPerUnitX ";
                        break;
                    case 0x5112:
                        s = "PixelPerUnitY ";
                        break;
                    case 0x5113:
                        s = "PaletteHistogram ";
                        break;
                    case 0x8298:
                        s = "Copyright ";
                        break;
                    case 0x829A:
                        s = "ExifExposureTime ";
                        break;
                    case 0x829D:
                        s = "ExifFNumber ";
                        break;
                    case 0x8769:
                        s = "ExifIFD ";
                        break;
                    case 0x8773:
                        s = "ICCProfile ";
                        break;
                    case 0x8822:
                        s = "ExifExposureProg ";
                        break;
                    case 0x8824:
                        s = "ExifSpectralSense ";
                        break;
                    case 0x8825:
                        s = "GpsIFD ";
                        break;
                    case 0x8827:
                        s = "ExifISOSpeed ";
                        break;
                    case 0x8828:
                        s = "ExifOECF ";
                        break;
                    case 0x9000:
                        s = "ExifVer ";
                        break;
                    case 0x9003:
                        s = "ExifDTOrig ";
                        break;
                    case 0x9004:
                        s = "ExifDTDigitized ";
                        break;
                    case 0x9101:
                        s = "ExifCompConfig ";
                        break;
                    case 0x9102:
                        s = "ExifCompBPP ";
                        break;
                    case 0x9201:
                        s = "ExifShutterSpeed ";
                        break;
                    case 0x9202:
                        s = "ExifAperture ";
                        break;
                    case 0x9203:
                        s = "ExifBrightness ";
                        break;
                    case 0x9204:
                        s = "ExifExposureBias ";
                        break;
                    case 0x9205:
                        s = "ExifMaxAperture ";
                        break;
                    case 0x9206:
                        s = "ExifSubjectDist ";
                        break;
                    case 0x9207:
                        s = "ExifMeteringMode ";
                        break;
                    case 0x9208:
                        s = "ExifLightSource ";
                        break;
                    case 0x9209:
                        s = "ExifFlash ";
                        break;
                    case 0x920A:
                        s = "ExifFocalLength ";
                        break;
                    case 0x927C:
                        s = "ExifMakerNote ";
                        break;
                    case 0x9286:
                        s = "ExifUserComment ";
                        break;
                    case 0x9290:
                        s = "ExifDTSubsec ";
                        break;
                    case 0x9291:
                        s = "ExifDTOrigSS ";
                        break;
                    case 0x9292:
                        s = "ExifDTDigSS ";
                        break;
                    case 0xA000:
                        s = "ExifFPXVer ";
                        break;
                    case 0xA001:
                        s = "ExifColorSpace ";
                        break;
                    case 0xA002:
                        s = "ExifPixXDim ";
                        break;
                    case 0xA003:
                        s = "ExifPixYDim ";
                        break;
                    case 0xA004:
                        s = "ExifRelatedWav ";
                        break;
                    case 0xA005:
                        s = "ExifInterop ";
                        break;
                    case 0xA20B:
                        s = "ExifFlashEnergy ";
                        break;
                    case 0xA20C:
                        s = "ExifSpatialFR ";
                        break;
                    case 0xA20E:
                        s = "ExifFocalXRes ";
                        break;
                    case 0xA20F:
                        s = "ExifFocalYRes ";
                        break;
                    case 0xA210:
                        s = "ExifFocalResUnit ";
                        break;
                    case 0xA214:
                        s = "ExifSubjectLoc ";
                        break;
                    case 0xA215:
                        s = "ExifExposureIndex ";
                        break;
                    case 0xA217:
                        s = "ExifSensingMethod ";
                        break;
                    case 0xA300:
                        s = "ExifFileSource ";
                        break;
                    case 0xA301:
                        s = "ExifSceneType ";
                        break;
                    case 0xA302:
                        s = "ExifCfaPattern ";
                        break;
                    default:
                        //continue;
                        s = "Unknown";
                        break;

                }
                row.SubItems.Add(s);
                string svalue = null;
                try
                {
                    switch (propitem.Type.ToString())
                    {
                        case "2":
                            svalue = System.Text.Encoding.UTF8.GetString(propitem.Value);
                            break;
                        case "4":
                            svalue = System.BitConverter.ToInt32(propitem.Value, 0).ToString();
                            break;
                        case "3":
                            svalue = System.BitConverter.ToUInt16(propitem.Value, 0).ToString();
                            break;
                        case "5":
                            svalue += System.BitConverter.ToUInt32(propitem.Value, 0).ToString();
                            //svalue += System.BitConverter.ToUInt32(propitem.Value, 4).ToString();
                            break;
                        case "9":
                            svalue = System.BitConverter.ToInt32(propitem.Value, 0).ToString();
                            break;
                        case "10":
                            svalue += System.BitConverter.ToInt32(propitem.Value, 0);
                            svalue += "  ";
                            svalue = System.BitConverter.ToInt32(propitem.Value, 4).ToString();
                            break;
                        case "1":
                            svalue = propitem.Value[0].ToString();
                            break;
                        case "7":
                            for (int j = 0; j < propitem.Value.Length; j++)
                            {
                                svalue += propitem.Value[j].ToString();
                                //Console.Write(" ");
                            }
                            Console.WriteLine();
                            break;
                        default:
                            svalue = "UNKNOW TYPE";
                            break;
                    }
                }
                catch (Exception ee)
                {
                }
                row.SubItems.Add(svalue);
            #endregion
                row.SubItems.Add(propitem.Type.ToString());
                list1.Items.Add(row);
                count++;
            }
        }

        private void openFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            btnopen.PerformClick();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult dres;
            dres = MessageBox.Show("Are you sure?", "Exit", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (dres == DialogResult.Yes)
                Close();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAbout frm = new frmAbout();
            frm.ShowDialog();
        }
            
        }
    }
